Bug 163231 - vertical writing is messed up
vertical writing is messed up
Product: Fedora
Classification: Fedora
Component: ghostscript (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Tim Waugh
: i18n
Depends On:
Blocks: FC7Target
  Show dependency treegraph
Reported: 2005-07-14 06:31 EDT by Akira TAGOH
Modified: 2007-11-30 17:11 EST (History)
2 users (show)

See Also:
Fixed In Version: 8.15.4-3.fc7
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2007-04-17 06:13:12 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
another testcase (1.84 KB, text/plain)
2005-07-14 06:41 EDT, Akira TAGOH
no flags Details
a screenshot on FC4 (24.74 KB, image/png)
2005-07-19 21:33 EDT, Akira TAGOH
no flags Details
a screenshot on devel (23.97 KB, image/png)
2005-07-19 21:34 EDT, Akira TAGOH
no flags Details
a patch to exactly enable CIDFnmap (4.61 KB, text/x-patch)
2007-04-17 01:45 EDT, Akira TAGOH
no flags Details

  None (edit)
Description Akira TAGOH 2005-07-14 06:31:52 EDT
Description of problem:
PostScript file which contains the vertical writing stuff is passed through gs8,
the rendered vertical writing glyphs are all messed up.

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
1.gs -sDEVICE=x11 /usr/share/printconf/tests/test-euc.ps
2.look at the vertical writing
Actual results:
the baseline for the vertical writing isn't correct.

Expected results:
the vertical writing should be rendered correctly.

Additional info:
This is an regression bug.
Comment 1 Akira TAGOH 2005-07-14 06:41:34 EDT
Created attachment 116741 [details]
another testcase
Comment 2 Akira TAGOH 2005-07-19 21:33:33 EDT
Created attachment 116956 [details]
a screenshot on FC4
Comment 3 Akira TAGOH 2005-07-19 21:34:06 EDT
Created attachment 116957 [details]
a screenshot on devel
Comment 4 Akira TAGOH 2005-07-19 22:06:48 EDT
Please compare between both screenshots. you will notice that there is two
problems at least. one is, apparently the direction of the grouping symbols are
wrong. it's because gs uses the glyphs of the horizontal writing for the
vertical writing. one is, the baseline of the glyphs are not the center and it
looks bad.
Comment 5 Tim Waugh 2005-07-20 11:45:04 EDT
Ick.  Not even sure where to start on this one. :-(
Comment 6 Tim Waugh 2005-07-27 13:33:26 EDT
davidz: Could this be related to freetype?
Comment 7 Akira TAGOH 2005-07-28 01:04:39 EDT
I doubt it. as I mentioned at comment #4, there is two problems for the vertical
writing and I suspect gs8 is doing wrong for them.

If these two problems should be filed as the separated bugs, I will.

1. wrong glyph are used. I mean even if CMap for the vertical writing, such as
-V is specified, the glyphs for the horizontal writing is used.  Actually the
fonts has the glyphs for the vertical writing and freetype is just rendering it
with given glyph ID. so gs8 must passes the proper glyph ID to freetype.

2. baseline of glyphs are wrong. basically it's different between the horizontal
writing and the vertical writing. but gs8 always calculates it with the
horizontal writing's baseline. this isn't also freetype fault, but gs8 fault.
Comment 8 Tim Waugh 2005-08-04 10:22:46 EDT
How is this meant to work?  Should GothicBBB-Medium-EUC-H and
GothicBBB-Medium-EUC-V map to different ttf files?
Comment 9 Akira TAGOH 2005-08-05 01:50:07 EDT
No, same ttf files but different CID.
Comment 10 Tim Waugh 2005-08-09 09:56:19 EDT
8.15-0.rc3.7 has some CMaps that had been missing.  Does this vertical writing
problem still happen with that version?  I can see differences from both
screenshots in the resulting output, but I'm not sure what's right. :-/
Comment 11 Akira TAGOH 2005-08-10 07:10:30 EDT
Unfortunately it's still there. why it looks different is now Sazanami fonts are
used for default Japanese fonts instead of Kochi.
I'm investigating this problem now BTW.
Comment 12 Akira TAGOH 2006-06-06 23:06:43 EDT
it seems that CJKV patch for gs-esp 8 has been committed into gs-esp svn at
r165. it may be worth trying to confirm if this bug and Bug #167596 is fixed or
not. just FYI.
Comment 13 Jong Bae KO 2006-06-15 02:12:04 EDT
------- Additional Comments From twaugh@redhat.com  2006-06-09 12:42 EST -------
I'm building 8.15.2-5 from r165, so we'll find out.
Comment 14 Tim Waugh 2006-06-15 04:58:16 EDT
Please try 8.15.2-6, which contains the change from 164:165.  Let me know if
this fixes the problem.
Comment 15 Jong Bae KO 2006-06-15 05:14:46 EDT
------- Additional Comments From twaugh@redhat.com  2006-06-13 12:06 EST -------
Please try 8.15.2-6 from rawhide.  Does that work any better than it did originally?
Comment 16 Akira TAGOH 2006-06-16 08:31:44 EDT
Hmm, it looked like the same. will have a look more later.
Comment 17 Akira TAGOH 2007-04-17 01:45:47 EDT
Created attachment 152767 [details]
a patch to exactly enable CIDFnmap

Attached patch will exactly applies fonts in CIDFnmap even if the same
fontnames are already registered into gs from FAPIcidfmap say.
Comment 18 Tim Waugh 2007-04-17 06:13:12 EDT
Thanks!  Applied in ghostscript-8.15.4-3.fc7.

Note You need to log in before you can comment on or make changes to this bug.